//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2
#property indicator_level1  0.0

//
//
//    fft library made by klot
//
//

#import "#_lib_FFT.ex4"
   void realfastfouriertransform(double& a[], int tnn, bool inversefft);
#import

//
//
//
//
//
extern string Note1 = "0 - signal, 1 - transformation";
extern int type = 0; // 0 - calc values 1 -calc size
extern string Note2 = "value for the signal ";
extern int value = 0;
extern string Note3 ="0 - frequency, 1 - amplitude, 2- both";  
extern int filterOP = 2;
extern double filterAMP = 0.001;
extern int FilterBellow     =   2;
extern int FilterAbove      =  50;
extern int Price            = PRICE_CLOSE;
extern int Window           = 256;
extern int StartDrawingFrom = 250;

//
//
//
//
//

double fft[];
double values[];
double calcValues[];
int    initialSize;
double transform[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   IndicatorBuffers(2);
      SetIndexBuffer(0,fft);
      SetIndexBuffer(1,values);
      
      //
      //
      //
      //
      //
      
      int n           = NormalizeDouble(MathLog(Window)/MathLog(2),0);
          initialSize = MathMax(MathPow(2,n),16);
          ArrayResize(calcValues,initialSize);
          ArrayResize(transform,initialSize);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,i,counted_bars = IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;   
           limit=MathMin(Bars-counted_bars,Bars-1);

   
   //
   //
   //
   //
   //
   
      for(i=limit; i>=0; i--)
      {
         values[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         
         //
         //
         //
         //
         //
         
         if (i<=StartDrawingFrom)
         {
            int calcSize = initialSize;
            if (calcSize>Bars)
            {
               int n        = NormalizeDouble(MathLog(Bars)/MathLog(2),0);
                   calcSize = MathMax(MathPow(2,n),16);
                      if (calcSize>Bars) calcSize = MathMax(MathPow(2,n-1),16);
            }      
            if (calcSize>Bars)     break;
            if ((Bars-i)<calcSize) continue;
            if (ArraySize(calcValues) != calcSize) ArrayResize(calcValues,calcSize);
                ArrayCopy(calcValues,values,0,i,calcSize);
            if (ArraySize(transform) != calcSize) ArrayResize(transform,calcSize);
                ArrayCopy(transform,values,0,i,calcSize);

            //
            //
            //
            //
            //
            int k=0;
            
            realfastfouriertransform(calcValues,calcSize,false);
            for(int a=0; a<calcSize; a++) transform [a] = calcValues [a];
               
             if (filterOP == 0){
               for( k=0; k<calcSize; k++) if (k<FilterBellow || k>FilterAbove) calcValues[k]=0.0;
             } else if (filterOP==1){
               for( k=0; k<calcSize; k++) if (calcValues[k] < filterAMP) calcValues[k]=0.0;             
             } else if (filterOP==2){
               for( k=0; k<calcSize; k++) if (k<FilterBellow || k>FilterAbove) calcValues[k]=0.0;
               for( k=0; k<calcSize; k++) if (calcValues[k] < filterAMP && calcValues[k] > (-filterAMP)) calcValues[k]=0.0;             
             }
             
            realfastfouriertransform(calcValues,calcSize,true);
            
            if (type == 0 ) {
            fft[i] = calcValues[value];
            } else if (type == 1 ) {
            fft[i] = transform[value];
            }
         }                   
      }         

   //
   //
   //
   //
   //
      
   SetIndexDrawBegin(0,Bars-StartDrawingFrom);
   return(0);
}